#include clientscripts\_utility;
#include clientscripts\_music;

main()
{
	clientscripts\_load::main();

	clientscripts\omahabeach_fx::main();
	
	thread clientscripts\_audio::audio_init(0);

	thread clientscripts\omahabeach_amb::main();
	
	clientscripts\_vehicle::build_treadfx( "corsair" );

	thread waitforclient(0);

	thread sideSmoke();
	thread beach_mgs_init();
	
	println( "*** Client : omahabeach running..." );	
}

sideSmoke()
{
	println( "*** Client : Starting side smoke" );

	smoke1 = getstruct( "sideSmoke1","targetname" );
	smoke2 = getstruct( "sideSmoke2","targetname" );
	
	playfx (0, level._effect[ "side_smoke" ], smoke1.origin, anglestoforward( smoke1.angles ) );
	playfx (0, level._effect[ "side_smoke" ], smoke2.origin, anglestoforward( smoke2.angles ) );

}

ambient_mgs( delayStart )
{
	if( delayStart )
	{
		wait( RandomFloatRange( 0.25, 3.5 ) );
	}
	
	fireSound = "weap_type92_fire";
	weapType = "mg";
	
	muzzleFlash = level._effect["distant_muzzleflash"];
	soundChance = 45;
	burstMin = 3;
	burstMax = 12;
	betweenShotsMin = 0.112;
	betweenShotsMax = 0.113;
	reloadTimeMin = 0.3;
	reloadTimeMax = 3.0;
	
	burst_area = ( 1000, 4520, 1000 );
	
	traceDist = 10000;
	temp_target = getStruct( self.target, "targetname" );
	ASSERTEX( IsDefined( temp_target ), "Can't find fake MG target spot for MG at: " + self.origin );
	orig_target = self.origin + vector_multiply( AnglesToForward( VectorToAngles( temp_target.origin - self.origin ) ),  traceDist );
	target_org = spawn ( 0, orig_target, "script_origin" );
		
	while( 1 )
	{
		burst = RandomIntRange( burstMin, burstMax );

		targ_point = (	(orig_target[0]) - (burst_area[0]/2) + randomfloat(burst_area[0]),
						(orig_target[1]) - (burst_area[1]/2) + randomfloat(burst_area[1]), 
						(orig_target[2]) - (burst_area[2]/2) + randomfloat(burst_area[2]));
		
		target_org moveto(targ_point, randomfloatrange(0.5, 6.0));
		
		for ( i = 0; i < burst; i++ )
		{			
			target = target_org.origin;

			fx_angles = VectorNormalize(target - self.origin);
			PlayFX( 0, muzzleFlash, self.origin, fx_angles );
			
			if (self.origin[0] > 1850 && self.origin[0] < 2300)
			{
				thread whiz_by_sound( self.origin, target );
			}
			
			playsound ( 0, "pacific_fake_fire", self.origin );
			
			if( RandomInt( 100 ) <= soundChance )
			{
				playsound( 0, fireSound, self.origin );
			}
			
			wait( RandomFloatRange( betweenShotsMin, betweenShotsMax ) );
		}
		
		wait( RandomFloatRange( reloadTimeMin, reloadTimeMax ) );
	}
	
}

beach_mgs_init()
{
	println( "*** Client : Starting beach MGs" );
	
	firePoints = GetStructArray( "fake_mgs", "targetname" );
	ASSERTEX( IsDefined( firePoints ) && firePoints.size > 0, "Can't find fake MG spots." );
		  	  				
	array_thread( firePoints, ::ambient_mgs, true );
}

whiz_by_sound( start, end )
{
	org = spawn (0, start, "script_origin");

	org moveto (end, 4);
	
	fake_ent = spawnfakeent(0);
	setfakeentorg( 0, fake_ent, start );
	playloopsound( 0, fake_ent, "pel1_beach_whizby"); 
	
	org thread whiz_by_sound_mover( fake_ent );
	
	org waittill ( "movedone" );
	deletefakeent( 0, fake_ent );
	org delete();
}

whiz_by_sound_mover( fake_ent )
{
	self endon ( "movedone" );

	while (1)
	{
		realwait( 0.05 );
		setfakeentorg( 0, fake_ent, self.origin );
	}
}