#include maps\_utility;
#include maps\_ambientpackage;
#include maps\_music;
#include common_scripts\utility;
#include maps\_busing;

main()
{
	//************************************************************************************************
	//				ACTIVATE DEFAULT AMBIENT SETTINGS
	//************************************************************************************************
	
	activateAmbientPackage( "omahabeach_outdoors", 0 );
	activateAmbientRoom( "omahabeach_outdoors", 0 );
	
	flag_wait( "player_is_on_mg" );
	
	thread germanNagging();
	thread planeInit();
	thread radioPlay();
}

//************************************************************************************************
//			 	OTHER AUDIO FUNCTIONS
//************************************************************************************************

radioPlay()
{
	level endon ( "ready_for_finale" );
	
	flag_wait( "player_is_on_mg" );
	
	//radio = getStruct( "bunkerRadio", "targetname" );
	//assertEx( isDefined( radio ), "Radio not defined." );
	
	radio = getStruct( "germanYelling", "targetname" );
	assertEx( isDefined( radio ), "German yelling struct not defined." );
	
	if( !isDefined( radio ) )
	{
		return;
	}
	
	radio endon ( "death" );
	
	/#
		iPrintLnBold( "Radio Playing." );
	#/

	while( 1 )
	{
		playsoundatposition( "radio", radio.origin );
		
		wait ( 37.5 );
	}
	
	/#
		iPrintLnBold( "Radio Stopped Playing." );
	#/
}

planeInit()
{
	level waittill ( "spawnvehiclegroup1" ); // Notification from _vehicles.gsc
	
	wait( 0.3 );
	
	planes = getEntArray( "usa_planes", "targetname" );
	assertEx( isDefined( planes ), "Planes not properly defined." );
	
	array_thread( planes, ::planeSound );
}

planeSound()
{
	self endon ( "death" );
	
	//if( IsDefined( self.script_sound ) )
	//{
		/#
			iPrintLnBold( "Playing flyby sound" );
		#/
		
		self PlaySound( "intro_plane" + RandomIntRange( 1, 4 ) );
	//}
}

germanNagging()
{
	level endon ( "ready_for_finale" );
	
	speaker = getStruct( "germanYelling", "targetname" );
	assertEx( isDefined( speaker ), "German yelling struct not defined." );
	
	// These are taken from ge_battleChatter.csv
	VOs = [];
	VOs[ VOs.size ] = "GE_0_direction_relative_west";
	VOs[ VOs.size ] = "GE_0_direction_relative_south";
	VOs[ VOs.size ] = "GE_0_direction_relative_north";
	VOs[ VOs.size ] = "GE_0_direction_relative_east";
	VOs[ VOs.size ] = "GE_0_direction_relative_northeast";
	VOs[ VOs.size ] = "GE_0_direction_relative_southeast";
	VOs[ VOs.size ] = "GE_0_direction_relative_southwest";
	VOs[ VOs.size ] = "GE_0_direction_relative_northwest";
	VOs[ VOs.size ] = "GE_0_inform_killfirm_infantry";
	VOs[ VOs.size ] = "GE_0_order_attack_infantry";
	VOs[ VOs.size ] = "GE_0_reaction_casualty_generic";
	
	while( 1 )
	{
		if( flag( "ready_for_finale" ) )
		{
			break;
		}
		
		if( randomInt( 100 ) > 40 )
		{
			playsoundatposition( VOs[ RandomInt( VOs.size ) ], speaker.origin );
		}
		
		wait( randomFloatRange( 5.32, 15.83 ) );
	}
}

germanDeathScreams()
{
	// Taken from ge_battleChatter.csv
	wait ( randomFloatRange( 0.13, 0.21 ) );
	self playSound( "generic_death_german" );
}

germanPainScreams()
{
	self endon ( "damage" );
	
	while( 1 )
	{
		// Taken from ge_battleChatter.csv
		self playSound( "generic_pain_german", "sounddone" );
		self waittill ( "sounddone" );
		
		wait ( randomFloatRange( 0.3, 0.6 ) );
	}
}

shingleBlowYell( shingle )
{
	VOs = [];
	VOs[ VOs.size ] = "US_0_inform_incoming_grenade_1";
	VOs[ VOs.size ] = "US_0_inform_incoming_grenade_2";
	
	shingle playSound( VOs[ randomInt( VOs.size ) ] );
}

shingleTriggerYell( dude )
{
	dude endon ( "death" );
	
	VOs = [];
	VOs[ VOs.size ] = "US_0_gametype_sd_friendlyplant_1";
	VOs[ VOs.size ] = "US_0_gametype_sd_friendlyplant_2";
	VOs[ VOs.size ] = "US_0_gametype_sd_friendlyplant_3";
	VOs[ VOs.size ] = "US_1_gametype_sd_friendlyplant_1";
	VOs[ VOs.size ] = "US_1_gametype_sd_friendlyplant_2";
	VOs[ VOs.size ] = "US_1_gametype_sd_friendlyplant_3";
	VOs[ VOs.size ] = "US_2_gametype_sd_friendlyplant_1";
	VOs[ VOs.size ] = "US_2_gametype_sd_friendlyplant_2";
	VOs[ VOs.size ] = "US_2_gametype_sd_friendlyplant_3";
	
	dude PlaySound( VOs[ RandomInt( VOs.size ) ] );
}