#include maps\_utility;
#include common_scripts\utility;
#include maps\_anim;

#using_animtree ("generic_human");
main()
{	
	// Body Animations
	thread bodyAnims();
	
	// Sound Animations
	thread soundAnims();
	
	// Player Animations
	thread playerAnims();
	
	// Note Tracks
	thread noteTracks();
}

bodyAnims()
{
	level.scr_anim[ "generic" ][ "prone_dive" ]				= %ch_sniper_resnov_cheer_dive;
	level.scr_anim[ "generic" ][ "wounded_bunker" ][ 0 ]				= %ai_wounded_belly_a;
}

soundAnims()
{
}

#using_animtree( "player" );
playerAnims()
{
	level.scr_animtree[ "player_hands" ] = #animtree;
	level.scr_model[ "player_hands" ] = "viewmodel_ger_wermacht_player";
	level.scr_anim[ "player_hands" ][ "intro" ] = %int_seelow1_intro_player;
	level.scr_anim[ "player_hands" ][ "outro" ] = %int_seelow1_outro_player;
}

noteTracks()
{
	addNotetrack_customFunction( "player_hands", "hands_in1", ::showHands, "intro" );  
	addNotetrack_customFunction( "player_hands", "hands_out1", ::hideHands, "intro" );  
	addNotetrack_customFunction( "player_hands", "hands_in2", ::showHands, "intro" );  
	addNotetrack_customFunction( "player_hands", "hands_out2", ::hideHands, "intro" );  
}

showHands( hand )
{
}

hideHands( hand )
{
}

#using_animtree ( "player" );
playerAnimFinale( player, anim_node )
{
	if( !isDefined( player ) )
	{
		// Make sure player is defined here.
		player = get_players()[0];
	}
	
	player SetDoubleVision( 2.5, 0.09 );
	player SetBlur( 0.7, 0.09 ); 
	
	hands = spawn_anim_model( "player_hands" );
	hands.animname = "player_hands";
	hands.origin = anim_node.origin;
	hands.angles = anim_node.angles;

	player PlayerLinkTo( hands, "tag_player", 1.75, 0, 0, 0, 0 );

	player hide();

	anim_node anim_single_solo( hands, "intro" ); 

	hands Delete();
}