#include common_scripts\utility;
#include maps\_utility;
#include maps\_utility_code;
#include maps\omahabeach_util;
#include maps\omahabeach_amb;
#include maps\_vehicle;
#include maps\_anim;
#include maps\_music; 
#include maps\_busing;

/***********************************************************************
	LEVEL
***********************************************************************/

map_startPoint()
{
	/*--------------------
	 DEFAULT START POINT
	----------------------*/
	
	thread threadCalls();
	
	flag_wait( "all_players_connected" );
	
	flag_wait( "armada_time" );
	
	delaythread( 1, ::higginsInit, "higgins_4", undefined, true );
	delaythread( 2, ::higginsInit, "higgins_3", undefined, true );
	delaythread( 8, ::higginsInit, "higgins_with_tank", true, true, 1.99 );
	//deaythread( 10, ::radioPlay, getEnt( "bunkerRadio", "targetname" ) ); // Moved to amb gsc
	//delaythread( 10, ::higginsTankShotCheck );
	delaythread( 15, ::higginsInit, "higgins_7", undefined, true, true );
	delaythread( 16, ::spawn_vehicles_from_targetname_and_drive, "usa_planes" );
	delaythread( 27, ::higginsInit, "higgins_1", undefined, true, true );
	delaythread( 35, ::higginsInit, "higgins_6", undefined, true, true );
	delaythread( 40, ::higginsInit, "higgins_2", undefined, true, true );
	delaythread( 50, ::higginsInit, "higgins_5", undefined, true, true );
}

bunker_startPoint()
{
	/*--------------------
	 BUNKER START POINT
	----------------------*/
	
	flag_wait( "all_players_connected" );
	
	thread bunkerFinale();
}

levelVariables()
{
	/*--------------------
	 LEVEL VARIABLES
	----------------------*/
	
	// I edited _drones.gsc so drones won't go into Ragdoll if this is true.
	// Was gettng too many Ragdolls on the beach.
	level.droneSkipRagoll = true;
	
	level.higginsLine = [];
	level.higginsMoving = 0;
}

flagInits()
{
	/*--------------------
	 FLAGS
	----------------------*/
	
	flag_init( "armada_time" );
	flag_init( "player_is_on_mg" );
	flag_init( "ready_for_finale" );
	flag_init( "ready_to_blow_up" );
	flag_init( "shingle_blown" );
	flag_init( "shingle_can_blow" );
	flag_init( "tank_higgin_destroyed" );
	flag_init( "tank_higgin_shoot" );
}

preCacheStuff()
{
	/*--------------------
	 PRECACHE
	----------------------*/
	
	// Strings
	precacheString( &"OMAHABEACH_INTRO_1_A" );
	precacheString( &"OMAHABEACH_INTRO_1_B" );
	precacheString( &"OMAHABEACH_INTRO_2_A" );
	precacheString( &"OMAHABEACH_INTRO_2_B" );
	precacheString( &"OMAHABEACH_INTRO_3_A" );
	precacheString( &"OMAHABEACH_INTRO_3_B" );
	precacheString( &"OMAHABEACH_INTRO_4_A" );
	precacheString( &"OMAHABEACH_INTRO_4_B" );
	precacheString( &"OMAHABEACH_INTRO_5_A" );
	precacheString( &"OMAHABEACH_INTRO_5_B" );
	precacheString( &"OMAHABEACH_START_DEFAULT" );
	precacheString( &"OMAHABEACH_START_BUNKER" );
	
	// Shellshock
	precacheShellShock( "frag_grenade_mp" );
	
	// Shaders
	precacheShader( "white" );
	precacheShader( "black" );
	
	// Items
	precacheItem( "m1garand" ); // Not sure if this is really needed.
	
	// Drones
	character\char_usa_marine_r_rifle::precache();
}

scriptCalls()
{
	/*--------------------
	 SCRIPT CALLS
	----------------------*/
	
	maps\_flak88::main( "artillery_ger_flak88" );
	maps\_aircraft::main( "vehicle_usa_aircraft_f4ucorsair_dist", "corsair", 0, 1 );
}

threadCalls()
{
	/*--------------------
	 THREAD CALLS
	----------------------*/
	
	thread lightFlicker();
	thread beachMortars();
	thread waterMortars();
	thread playerSetup();
	thread beachDronesRunAnims();
	thread beachDrones();
	thread higginsRandomDudes();
	thread flak88Spawn();
	thread shinglesLogic();
	thread higginsQueue();
	custom_introscreen();
	
	wait ( 0.2 );
	objective();
}

myTeamHack()
{
	self.goalradius = 4;
	self.pacifist = 1;
	self.team = "allies";
	self.name = undefined; // Don't show friendly names, more cinematic feel
}

theirTeamHack()
{
	self.goalradius = 1024;
	self.team = "axis";
	self.name = undefined;
	self.ignoresuppression = randomInt( 1 );
	self SetThreatBiasGroup( "beachAI" );
}

custom_introscreen()
{
	level.introblack = NewHudElem(); 
	level.introblack.x = 0; 
	level.introblack.y = 0;
	level.introblack.sort = 1;
	level.introblack.horzAlign = "fullscreen"; 
	level.introblack.vertAlign = "fullscreen"; 
	level.introblack SetShader( "black", 640, 480 );
	
	// Set the music state
	setmusicstate( "INTRO" );
	
	thread freezecontrols_all( true );
	
	wait( 2 );
	
	if( !devCheck( "skip_intro" ) )
	{ 
		level.player thread titleCreate( &"OMAHABEACH_INTRO_1_A", "left" );
		level.player titleCreate( &"OMAHABEACH_INTRO_1_B", "right" );
	
		level.player thread titleCreate( &"OMAHABEACH_INTRO_2_A", "left" );
		level.player titleCreate( &"OMAHABEACH_INTRO_2_B", "right" );
		
		level.player thread titleCreate( &"OMAHABEACH_INTRO_3_A", "left" );
		level.player titleCreate( &"OMAHABEACH_INTRO_3_B", "right" );
		
		level.player thread titleCreate( &"OMAHABEACH_INTRO_4_A", "left" );
		level.player titleCreate( &"OMAHABEACH_INTRO_4_B", "right" );
		
		flag_set( "armada_time" );
		
		level.player thread titleCreate( &"OMAHABEACH_INTRO_5_A", "left" );
		level.player titleCreate( &"OMAHABEACH_INTRO_5_B", "right", 7.0 + 3.0 );
	}
	else
	{
		flag_set( "armada_time" );
	}
	
	level notify ( "introscreen_will_be_done" );
	
	flag_wait( "player_is_on_mg" );
	
	wait ( 1.5 );
	
	// Fade out black
	level.introblack FadeOverTime( 0.5 ); 
	level.introblack.alpha = 0;
	
	wait ( 0.6 );
	
	// Give Controls Back
	thread freezecontrols_all( false );
	
	// Set the music state (looping)
	setmusicstate( "BATTLE" );
	
	level notify( "controls_active" ); // Notify when player controls have been restored
	level.introblack destroy();
}

playerSetup()
{	
	level.player SetClientDvars( "introscreen", "0",
												 "hud_showStance", "0",
												 "cg_drawcrosshair", "0",
												 "cg_drawturretcrosshair", "0",
												 "compass", "0",
												 "ammoCounterHide", "1",
												 "miniscoreboardhide", "1",
												 "ragdoll_enable", "1",
												 "ragdoll_max_life", "2800",
												 "ragdoll_max_simulating", "32",
												 "friendlyfire_enabled", "0" );
	level.player DisableWeapons();
	
	mg42 = getEnt( "player_mg42", "targetname" );
	assertEx( isDefined( mg42 ), "Player MG42 not defined" );
	
	level.player DisableTurretDismount();
	
	oceanPoint = getStruct( "player_oceanpoint", "targetname" );
	assertEx( isDefined( oceanPoint ), "No ocean point for player." );
	
	level.player.oceanLink = Spawn( "script_origin", level.player.origin );
	level.player PlayerLinkTo( level.player.oceanLink );
	level.player.oceanLink moveTo( oceanPoint.origin, 0.1 );
	
	level waittill ( "introscreen_will_be_done" );
	
	level.player.oceanLink moveTo( mg42.origin, 0.1 );
	level.player.oceanLink waittill ( "movedone" );
	level.player unLink();
	
	if( !devCheck( "free_me" ) )
	{ 
		mg42 UseBy( level.player );
	}
	
	flag_set( "player_is_on_mg" );
	
	level.player.oceanLink delete();
}

beachDrones()
{
	// This is all happening during introscreen so player does/should not see.
	//level endon ( "introscreen_will_be_done" );
	
	// Dead Drones
	deadBodys();
	
	// Wait Snapshot. Too Many Drones == Too Many Entities Per Snap
	wait_network_frame();
	
	// Floating Drones
	floatingBodys();
	
	// Wait Snapshot. Too Many Drones == Too Many Entities Per Snap
	wait_network_frame();
	
	// Wounded Drones
	woundedBodys();
	
	// Wait Snapshot. Too Many Drones == Too Many Entities Per Snap
	wait_network_frame();
	
	// Idle Drones
	idleBodys();
	
	// Wait Snapshot. Too Many Drones == Too Many Entities Per Snap
	wait_network_frame();
	
	// Running Drones
	trig = getEnt( "beachDrones_1", "script_noteworthy" );
	assertEx( isDefined( trig ), "No running drones trigger defined" );
	trig notify ( "trigger" );
	
	trig = undefined;
	
	// Wait Snapshot. Too Many Drones == Too Many Entities Per Snap
	wait_network_frame();
	
	// Crouch Drones
	trig = getEnt( "beachDrones_2", "script_noteworthy" );
	assertEx( isDefined( trig ), "No shooting drones trigger defined" );
	trig notify ( "trigger" );
	
	// Wait Snapshot. Too Many Drones == Too Many Entities Per Snap
	wait_network_frame();
	
	// Keep it quiet until after introscreen
	flag_wait( "player_is_on_mg" );
	
	// Shooting Drones
	trig = getEnt( "beachDrones_3", "script_noteworthy" );
	assertEx( isDefined( trig ), "No shooting drones trigger defined" );
	trig notify ( "trigger" );
	
	/#
		printLn( "Finished setting up initial drones." );
	#/
	
	flag_wait( "shingle_blown" );
	
	// Post-Shingle Breach Drones
	trig = getEnt( "beachDrones_4", "script_noteworthy" );
	assertEx( isDefined( trig ), "No running drones trigger defined" );
	trig notify ( "trigger" );
	
	/#
		printLn( "Finished setting up all drones." );
	#/
}

#using_animtree ( "sniper_crows" );
deadBodys()
{
	Bodies = getStructArray( "deadBody", "targetname" );
	assertEx( isDefined( Bodies ), "No dead body script_structs exist." );
	Bodies = array_randomize( Bodies );
	
	bodyCountMax = 17; // 60; // 150;
	if( Bodies.size < bodyCountMax )
	{
		bodyCountMax = Bodies.size;
	}
	
	deadAnims = [];
	deadAnims[ deadAnims.size ] = %ch_sniper_fountain_corpse1;
	//deadAnims[ deadAnims.size ] = %ch_sniper_fountain_corpse2;
	deadAnims[ deadAnims.size ] = %ch_sniper_fountain_corpse3;
	deadAnims[ deadAnims.size ] = %ch_sniper_fountain_corpse4;
	deadAnims[ deadAnims.size ] = %ch_sniper_fountain_corpse5;
	deadAnims[ deadAnims.size ] = %ch_sniper_fountain_corpse6;
	deadAnims[ deadAnims.size ] = %ch_sniper_fountain_corpse7;
	deadAnims[ deadAnims.size ] = %ch_sniper_fountain_corpse8;
	deadAnims[ deadAnims.size ] = %ch_sniper_fountain_corpse9;
	deadAnims[ deadAnims.size ] = %ch_sniper_fountain_corpse10;
	deadAnims[ deadAnims.size ] = %ch_sniper_fountain_corpse11;
	deadAnims[ deadAnims.size ] = %ch_sniper_fountain_corpse12;
	//deadAnims[ deadAnims.size ] = %ch_sniper_fountain_corpse13;
	//deadAnims[ deadAnims.size ] = %ch_sniper_fountain_corpse14;
	deadAnims[ deadAnims.size ] = %ch_sniper_fountain_corpse15;
	deadAnims[ deadAnims.size ] = %ch_sniper_fountain_corpse16;
	deadAnims[ deadAnims.size ] = %ch_sniper_fountain_corpse17;
	deadAnims[ deadAnims.size ] = %ch_sniper_fountain_corpse18;
	//deadAnims[ deadAnims.size ] = %ch_sniper_fountain_corpse19;
	deadAnims[ deadAnims.size ] = %ch_sniper_fountain_corpse20;
	//deadAnims[ deadAnims.size ] = %ch_sniper_fountain_corpse21;
	deadAnims[ deadAnims.size ] = %ch_sniper_fountain_corpse22;
	
	if( devCheck( "deadAnimCheck" ) )
	{
		thread animPreviewer( deadAnims, "sniper_crows" );
	}
	
	deadAnims2 = [];
	deadAnims2 = deadBodys_hack(); // Seelow anims not in 'sniper_crows'
	
	for( x = 0; x < bodyCountMax; x++ )
	{
		if( x % 10 == 0 )
		{
			guy = spawnDrone( Bodies[ x ].origin + (0,0,-15), Bodies[ x ].angles, "deadBody", 0, undefined, 10000, undefined, deadAnims2 );
		}
		else
		{
			guy = spawnDrone( Bodies[ x ].origin + (0,0,-15), Bodies[ x ].angles, "deadBody", 0, undefined, 10000, "sniper_crows", deadAnims );
		}
		
		wait ( 0.3 );
		
		if( x == 15 )
		{
			// Wait Snapshot. Too Many Drones == Too Many Entities Per Snap
			wait_network_frame();
		}
	}
}

#using_animtree ( "generic_human" );
deadBodys_hack()
{
	deadAnims2 =[];
	deadAnims2[ deadAnims2.size ] = %ch_seelow1_intro_deadguy;
	deadAnims2[ deadAnims2.size ] = %ch_seelow1_intro_deadguy2_dead;
	deadAnims2[ deadAnims2.size ] = %ch_seelow1_intro_deadguy_dead;
	
	return deadAnims2;
}

#using_animtree ( "generic_human" );
woundedBodys()
{
	Bodies = getStructArray( "woundBody", "targetname" );
	assertEx( isDefined( Bodies ), "No wounded body script_structs exist." );
	Bodies = array_randomize( Bodies );
	
	bodyCountMax = 6;
	if( Bodies.size < bodyCountMax )
	{
		bodyCountMax = Bodies.size;
	}
	
	woundAnims = [];
	woundAnims[ woundAnims.size ] = %ai_wounded_belly_a;
	woundAnims[ woundAnims.size ] = %ai_wounded_belly_b;
	//woundAnims[ woundAnims.size ] = %ai_deadly_wounded_torso_loop;
	
	for( x = 0; x < bodyCountMax; x++ )
	{
		guy = spawnDrone( Bodies[ x ].origin + (0,0,-15), Bodies[ x ].angles, "woundBody", 0, true, undefined, undefined, woundAnims );
		
		wait ( 0.3 );
		
		if( x == 15 )
		{
			// Wait Snapshot. Too Many Drones == Too Many Entities Per Snap
			wait_network_frame();
		}
	}
}

floatingBodys()
{
	Bodies = getStructArray( "floatBody", "targetname" );
	assertEx( isDefined( Bodies ), "No floating body script_structs exist." );
	Bodies = array_randomize( Bodies );
	
	bodyCountMax = 4; // Try to keep low otherwise too many ragdolls used.
	if( Bodies.size < bodyCountMax )
	{
		bodyCountMax = Bodies.size;
	}
	
	for( x = 0; x < bodyCountMax; x++ )
	{
		guy = spawnDrone( Bodies[ x ].origin + (0,0,-15), Bodies[ x ].angles, "floatBody", 0, undefined, 10000 );
		
		wait ( 0.3 );
		
		if( !isDefined( guy ) )
		{
			continue;
		}
		
		guy startRagDoll();
		
		if( x == 15 )
		{
			// Wait Snapshot. Too Many Drones == Too Many Entities Per Snap
			wait_network_frame();
		}
	}
}

idleBodys()
{
	Bodies = getStructArray( "idleBodys", "targetname" );
	assertEx( isDefined( Bodies ), "No idle body script_structs exist." );
	Bodies = array_randomize( Bodies );
	
	idleAnim = [];
	idleAnim[ idleAnim.size ] = "cover_stand";
	idleAnim[ idleAnim.size ] = "cover_crouch";
	
	bodyCountMax = 17;
	if( Bodies.size < bodyCountMax )
	{
		bodyCountMax = Bodies.size;
	}
	
	for( y = 0; y < bodyCountMax; y++ )
	{		
		guy = spawnDrone( Bodies[ y ].origin + (0,0,-15), Bodies[ y ].angles, "idleBody", 1, true, undefined, "fakeshooters" );
		
		wait ( 0.3 );
		
		if( !isDefined( guy ) )
		{
			continue;
		}
		
		guy thread maps\_drones::drone_cover( idleAnim[ RandomInt( idleAnim.size ) ] );
		
		if( y == 15 )
		{
			// Wait Snapshot. Too Many Drones == Too Many Entities Per Snap
			wait_network_frame();
		}
	}
}

#using_animtree ( "fakeshooters" );
beachDronesRunAnims()
{
	level.drone_run_cycle[ "run_deep_a" ] = %ai_run_deep_water_a; 
	level.drone_run_cycle[ "run_deep_b" ] = %ai_run_deep_water_b; 
	level.drone_run_cycle[ "run_fast" ]		= %combat_run_fast_3;
}

objective()
{
	Objective_Add( 0, "active", &"OMAHABEACH_OBJECTIVE" ); 
	Objective_Current( 0 ); 
}

beachMortars()
{
	maps\_mortar::set_mortar_delays( "beach_mortars", 1.3, 4.1, 1.3, 4.1 );
	maps\_mortar::set_mortar_range( "beach_mortars", 1, 10000 );
	maps\_mortar::set_mortar_damage( "beach_mortars", 256, 25, 50 );
	maps\_mortar::set_mortar_quake( "beach_mortars", 0.32, 3, 1800 );
	maps\_mortar::set_mortar_dust( "beach_mortars", "bunker_dust", 512 );

	level thread maps\_mortar::mortar_loop( "beach_mortars" );
}

waterMortars()
{
	maps\_mortar::set_mortar_delays( "water_mortars", 3.5, 5, 3.5, 5 );
  maps\_mortar::set_mortar_chance( "water_mortars", 0.5 );
  maps\_mortar::set_mortar_range( "water_mortars", 1, 10000 );
 	maps\_mortar::set_mortar_damage( "water_mortars", 0, 0, 0 );
 	maps\_mortar::set_mortar_quake( "water_mortars", 0.30, 2.5, 1000 );
 	
 	level thread maps\_mortar::mortar_loop( "water_mortars" );
}

flak88Spawn()
{
	vehicleArray1 = maps\_vehicle::scripted_spawn( 0 );	
	vehicleArray2 = maps\_vehicle::scripted_spawn( 2 );
	
	wait ( 1.0 );
	
	// Keep these babys quiet until after introscreen
	flag_wait( "player_is_on_mg" );
	
	assertEx( isDefined( vehicleArray1 ), "Didn't spawn Flak88 1." );
	assertEx( isDefined( vehicleArray2 ), "Didn't spawn Flak88 2." );
	
	vehicleArray1[ 0 ].targetname = "flak88_1";
	vehicleArray2[ 0 ].targetname = "flak88_2";
	
	thread flak88Think( vehicleArray1[ 0 ] );
	thread flak88Think( vehicleArray2[ 0 ] );
	
	/*
	flag_wait( "tank_higgin_shoot" );
	
	vehicleArray2[ 0 ] notify ( "stop_firing" );
	thread flak88Think( vehicleArray2[ 0 ], getEnt( "higgins_with_tank_sherman", "targetname" ) );
	
	vehicleArray2[ 0 ] waittill ( "turret_fire" );
	getEnt( "higgins_with_tank", "targetname" ) notify ( "death" );
	vehicleArray2[ 0 ] notify ( "stop_firing" );
	
	thread flak88Think( vehicleArray2[ 0 ] );
	*/
}

flak88Think( flak, forceTarget )
{
	flak endon ( "death" );
	flak endon ( "stop_firing" );
	
	targets = [];
	
	if( isDefined( forceTarget ) )
	{
		targets[ 0 ] = forceTarget;
	}
	else
	{
		targets = getStructArray( flak.targetname + "_target", "targetname" );
		assert( isDefined( targets ), "Flak default targets not defined for Flak at: " + flak.origin );
	}
		
	while( 1 )
	{
		wait ( randomFloatRange ( 4.75, 8.0 ) );
		
		flak SetTurretTargetVec( targets[ RandomInt( targets.size ) ].origin );
		flak waittill( "turret_on_target" );
		
		flak clearTurretTarget();
		
		//flak fireWeapon();
		flak notify ( "turret_fire" );
	}
}

shinglesLogic()
{
	dudes = getEntArray( "shingle_dudes", "targetname" );
	assertEx( isDefined( dudes ) && dudes.size > 0, "No shingle dudes defined." );
	shingle = getEnt( "shingles_model", "targetname" );
	assertEx( isDefined( shingle ), "No shingle model defined." );
	shingleTrigger = getEnt( "shingles_trigger", "targetname" );
	assertEx( isDefined( shingleTrigger ), "No shingle trigger defined." );
	goalNodes = getNodeArray( "shingles_nodes", "targetname" );
	assertEx( isDefined( goalNodes ), "No single nodes defined." );
	barbWire = getEnt( "shingles_barbwire", "targetname" );
	assertEx( isDefined( barbWire ), "No barb wire defined." );
	dirt = getEnt( "shingles_dirt", "targetname" );
	assertEx( isDefined( dirt ), "No shingles aftermath dirt defined." );
	
	dirt hide();
	shingle hide();
	
	for( x = 0 ; x < goalNodes.size ; x++ )
	{
		goalNodes[ x ]._claimed = false;
	}
	
	shingleTrigger thread shinglesLogic_Trigger();
	
	flag_wait( "player_is_on_mg" );
	
	thread shinglesLogic_TimeOut();
	
	while( 1 )
	{
		wait ( RandomIntRange( 5, 10 ) );
		
		guy = shinglesLogic_SpawnGuy( dudes );
		if( !isDefined( guy ) )
		{
			continue;
		}
		
		node = shinglesLogic_FindNode( goalNodes );
		if( !isDefined( node ) )
		{
			guy delete();
			
			continue;
		}
		
		guy thread shinglesLogic_SetGoal( node, true );
		
		if( flag( "ready_to_blow_up" ) )
		{
			break;
		}
	}
	
	thread shinglesLogic_Plant( shingle );
	
	flag_wait( "shingle_can_blow" );
	
	shingle show();
	
	wait ( 0.05 );
	
	shingle_target = getStruct( shingle.target, "targetname" );
	assertEx( isDefined( shingle_target ), "Shingle moveTo target not defined." );
	
	shingle moveTo( shingle_target.origin, 1.4 );
	shingle waittill ( "movedone" );
	
	wait ( 0.4 );

	shingle PlaySound( "mortar_dirt" );
	PlayFX( level._effect[ "beach_mortars" ], shingle.origin );
	
	shingle hide();
	dirt show();
	shingle delete();
	
	flag_set( "shingle_blown" );
	
	barbWire hide();
	barbWire connectPaths();
	barbWire delete();
	
	wait ( 1 );

	goalNodes = getNodeArray( "bunker_nodes", "targetname" );
	assertEx( isDefined( goalNodes ), "No bunker nodes defined." );
	shingleTrigger_Bunker = getEnt( "bunker_trigger", "targetname" );
	assertEx( isDefined( shingleTrigger_Bunker ), "No bunker trigger defined." );
	
	shingleTrigger_Bunker thread shinglesLogic_Trigger2();
	thread shinglesLogic_TimeOut2();
	
	while( 1 )
	{
		wait ( RandomIntRange( 3, 4 ) );
		
		guy = shinglesLogic_SpawnGuy( dudes );
		if( isDefined( guy ) )
		{
			node = shinglesLogic_FindNode( goalNodes );
			if( !isDefined( node ) )
			{
				guy delete();
			}
			else
			{
				guy thread shinglesLogic_SetGoal( node );
			}
		}
		
		if( flag( "ready_for_finale" ) )
		{
			break;
		}
	}
	
	mg42 = getEnt( "player_mg42", "targetname" );
	assertEx( isDefined( mg42 ), "Player MG42 not defined" );
	
	// UseBy again knocks player off -- I hope
	mg42 UseBy( level.player );
	thread bunkerFinale();
}

shinglesLogic_Plant( shingle )
{
	/*
	dudes =  GetAIArray( "axis", "allies" );
	
	AI = getclosest( shingle.origin, dudes );

	AI thread magic_bullet_shield();
	
	AI setGoalPos( shingle.origin );
	AI waittill ( "goal" );
	
	AI thread stop_magic_bullet_shield();
	*/
	
	
	shingleBlowYell( shingle );
	
	wait ( RandomFloatRange( 1.31, 1.89 ) );
	
	flag_set( "shingle_can_blow" );
}

shinglesLogic_TimeOut()
{
	level endon ( "ready_to_blow_up" );
	
	time = 200; // Seconds
	
	wait ( time );
	
	/#
		iPrintLnBold( "Flag set: ready_to_blow_up" );
	#/
	
	flag_set( "ready_to_blow_up" );
}

shinglesLogic_Timeout2()
{
	level endon ( "ready_for_finale" );
	
	time = 90; // Seconds
	
	wait ( time );
	
	/#
		iPrintLnBold( "Flag set: ready_for_finale" );
	#/
	
	flag_set( "ready_for_finale" );
}

shinglesLogic_SetGoal( node, doProneDrop )
{
	self endon ( "death" );
	
	self.animName = "generic";
	self setGoalNode( node );
	node._claimed = true;
	
	self thread shinglesLogic_SetGoal_DeathEvent( node );
	
	if( isDefined( doProneDrop ) && doProneDrop == true )
	{
		while( 1 )
		{
			if(  DistanceSquared( self.origin, node.origin ) <= 64 )
			{
				self.disablearrivals = true;
				self.disableexits = true;
				
				animtime = getAnimLength( level.scr_anim[ "generic" ][ "prone_dive" ] );
				self thread anim_generic_custom_animmode( self, "gravity", "prone_dive" );
		
				// Hack to stop AI from prone jumping then standing up and back to prone again.
				wait ( animtime - 0.05 ); // Anim time minus a frame
				if( self.a.pose != "prone" )
				{
					self.a.pose = "prone";
				}
		
				self allowedstances( "prone" );
				self setGoalPos( node.origin );
			}
			
			if( flag( "ready_to_blow_up" ) )
			{
				break;
			}
			
			wait ( 0.1 );
		}
	}
}

shinglesLogic_SetGoal_DeathEvent( node )
{
	self waittill( "death" );
	node._claimed = false;
}

shinglesLogic_Trigger()
{
	guysNeeded = 4;
	dudes = [];
	
	while( 1 )
	{
		wait ( RandomFloatRange( 1.25, 2.83 ) );
		
		dudes = GetAIArray( "axis", "allies" );
		
		if( !isDefined( dudes ) || dudes.size == 0 )
		{
			continue;
		}
		
		if( dudes.size < guysNeeded )
		{
			if( !isDefined( dudes[ 0 ] ) )
			{
				// No available guy for some reason
			}
			else if( RandomInt( 10 ) == 3 )
			{				
				thread shingleTriggerYell( dudes[ 0 ] );
			}
			
			continue;
		}
		
		count = 0;
		
		for( x = 0 ; x < dudes.size ; x++ )
		{
			if ( dudes[ x ] IsTouching( self ) )
			{
				count++;
			}
		}
		
		if( count >= guysNeeded )
		{
			flag_set( "ready_to_blow_up" );
			break;
		}
	}
}

shinglesLogic_Trigger2()
{
	guysNeeded = 5;
	
	while( 1 )
	{
		wait ( RandomFloatRange( 1.25, 2.83 ) );
		
		dudes = GetAIArray( "axis", "allies" );
		
		if( !isDefined( dudes ) || dudes.size == 0 )
		{
			continue;
		}
		
		if( dudes.size < guysNeeded )
		{			
			continue;
		}
		
		count = 0;
		
		for( x = 0 ; x < dudes.size ; x++ )
		{
			if ( dudes[ x ] IsTouching( self ) )
			{
				count++;
			}
		}
		
		if( count >= guysNeeded )
		{
			flag_set( "ready_for_finale" );
			break;
		}
	}
}

shinglesLogic_SpawnGuy( guys )
{
	dude = guys[ RandomInt( guys.size ) ] StalingradSpawn();
	if( spawn_failed( dude ) )
	{
		return undefined;
	}
		
	return dude;
}

shinglesLogic_FindNode( goalNodes )
{
	goalNodes = array_randomize( goalNodes );
	
	for( x = 0 ; x < goalNodes.size ; x++ )
	{
		if( isDefined( goalNodes[ x ]._claimed ) && goalNodes[ x ]._claimed == false )
		{
			return goalNodes[ x ];
		}
	}
	
	return undefined;
}

#using_animtree ( "generic_human" );
higginsInit( name, tank, triggerDamage, loop, scriptBrushModelRotationFix )
{
	higgin = getEnt( name, "targetname" );
	assertEx( isDefined( higgin ), "No higgin boat defined for: " + name );
	higgin._rideSpots = getStructArray( name + "_rides", "targetname" );
	assertEx( isDefined( higgin._rideSpots ), "No higgin boat ride spots defined for: " + name );
	higgin._startPoint = getStruct( name + "_startpoint", "targetname" );
	assertEx( isDefined( higgin._startPoint ), "No higgin boat start point defined for: " + name );
	higgin._ramp = getEnt( name + "_ramp", "targetname" );
	assertEx( isDefined( higgin._ramp ), "No higgin boat ramp defined for: " + name );
	higgin._trigger = undefined;
	higgin._trigger = getEnt( higgin.targetname + "_trigger", "targetname" );
	higgin._oldPos = higgin.origin;
	higgin._oldAngle = higgin.angles;
	higgin._oldRampAngle = higgin._ramp.angles;
	
	flag_init( name + "_goPath" );
	
	if( isDefined( tank ) && tank == true )
	{
		higgin._tank = getEnt( name + "_sherman", "targetname" );
		higgin._tank linkTo( higgin );
	}
	
	higgin higginsRampUp();
	higgin._ramp linkTo( higgin );
	
	idleAnim = [];
	idleAnim[ 0 ] = %crew_lvt4_passenger2_idle; 
	idleAnim[ 1 ] = %crew_lvt4_passenger3_idle; 
	idleAnim[ 2 ] = %crew_lvt4_passenger4_idle; 
 	idleAnim[ 3 ] = %crew_lvt4_passenger5_idle; 
 	idleAnim[ 4 ] = %crew_lvt4_passenger6_idle; 
 	idleAnim[ 5 ] = %crew_lvt4_passenger7_idle; 
 	idleAnim[ 6 ] = %crew_lvt4_passenger8_idle; 
 	idleAnim[ 7 ] = %crew_lvt4_passenger9_idle;
	
	while( 1 )
	{
		level.higginsLine = array_add( level.higginsLine, higgin );
		
		flag_wait( name + "_goPath" );
		
		if( isDefined( triggerDamage ) && triggerDamage == true )
		{
			if( isDefined( higgin._trigger ) )
			{
				// linkTo not supported for 'trigger'
				//higgin._trigger linkTo( higgin );
			
				higgin thread higginsTriggerMove();
				higgin thread higginDamage();
			}
		}
	
		higgin thread higginsSink();
   	
   	if( devCheck( "rideAnimCheck" ) )
   	{
   		thread animPreviewer( idleAnim );
   	}
   	
   	higgin._riders = [];
   	for( x = 0; x < higgin._rideSpots.size; x++ )
   	{
   		higgin._riders[ x ] = spawnDrone( higgin._rideSpots[ x ].origin + (0,0,-15), higgin._rideSpots[ x ].angles, "rideBody", 0, false, undefined, undefined, idleAnim );
   		
   		higgin._riders[ x ] linkTo( higgin );
   	}
   	
   	higgin._path = [];
   	higgin._path[ 0 ] = higgin._startPoint;
   	while( isDefined( higgin._path[ higgin._path.size - 1].target ) )
   	{
   		higgin._path[ higgin._path.size ] = getStruct( higgin._path[ higgin._path.size - 1].target, "targetname" );
   	}
   	
   	higgin thread higginsGoPath( scriptBrushModelRotationFix );
   	
   	level waittill (  name + "_sunk" );
   	
   	// Kill guys immediately as they walk out -- Temporary?
		aliveRiders = array_removeUndefined( higgin._riders );
		for( x = 0; x < aliveRiders.size; x++ )
		{
			aliveRiders[ x ] unLink();
			aliveRiders[ x ] delete();
		}
   	
   	if( !isDefined( loop ) )
   	{
   		break;
   	}
   	
   	higgin._ramp hide();
   	higgin hide();
   	higgin.origin = higgin._oldPos;
   	
   	wait ( 0.05 + 0.05 );
   	
   	level.higginsMoving -= 1;
   	
   	higgin.angles = higgin._oldAngle;
   	higgin._ramp show();
   	higgin show();
   	
   	flag_clear( name + "_goPath" );
  }
}

higginsTriggerMove()
{
	self endon ( "death" );
	
	while( 1 )
	{
		self._trigger.origin = self.origin;
		
		wait ( 0.3 );
	}
}

higginsRampUp()
{
	self endon ( "death" );
	
	self._ramp RotateTo( ( 90, 0, 0 ), 0.1 );
	
	wait ( 0.2 );
}

higginsDropRamp()
{
	self endon ( "death" );
	
	rotateValue = 45 * 1.5;
	rotateTime = 0.5;
	forward = undefined;
	
	self._riders = array_removeDead( self._riders );
	if( isDefined( self._riders[ 0 ] ) )
	{
		tempForward = AnglesToForward( self._riders[ 0 ].angles );
		forward = tempForward * ( rotateValue, 0, 0 );
	}
	else // Everybody is dead, sink!
	{
		self notify ( "death" );
		return;
	}
	
	self._ramp unLink();
	//self._ramp RotateTo( forward, rotateTime, rotateTime * 0.25, rotateTime * 0.25 );
	self._ramp RotateTo( self._oldRampAngle, rotateTime, rotateTime * 0.25, rotateTime * 0.25 );
}

higginDamage()
{
	self endon ( "death" );
	
	higginHealth = 800;
	
	while( 1 )
	{
		self._trigger waittill ( "damage", amount, attacker );
		
		if( amount >= higginHealth )
		{
			self notify ( "death" );
		}
		else
		{
			higginHealth -= amount;
		}
	}
	
	/*
	higginLife = 450;
	
	while( 1 )
	{
		self._trigger waittill ( "damage", amount, attacker, direction_vec, damage_ori, type );
		
		higginLife -= amount;
		
		if( higginLife <= 0 )
		{
			self notify ( "death" );
		}
		
		wait ( 0.05 );
	}
	*/
}

higginsSink()
{
	self waittill ( "death" );
	self notify ( "movedone" ); // Make sure higgins stops if it's on a path
	
	self PlaySound( "mortar_dirt" );
	PlayFX( level._effect[ "beach_mortars" ], self.origin );
	
	goal = self.origin - ( 0, 0, 256 );
	
	d = distance( self.origin, goal );
	moveTime = ( d / 150 );
		
	self moveTo( goal, moveTime );
	self waittill ( "movedone" );
	
	level notify ( self.targetname + "_sunk" );
}

higginsQueue()
{
	// Keep drone count down and allows for shooting gallery type spawning
	
	maxMovingBoats = 4;
	
	level endon ( "ready_for_finale" );

	while( 1 )
	{
		if( isDefined( level.higginsLine ) && isDefined( level.higginsLine[ 0 ] ) )
		{
			if( level.higginsMoving < maxMovingBoats )
			{
				level.higginsMoving += 1;
				
				flag_set( level.higginsLine[ 0 ].targetname + "_goPath" );
				
				/#
					iPrintLnBold( level.higginsLine[ 0 ].targetname + "_goPath" );
				#/
				
				level.higginsLine = array_remove( level.higginsLine, level.higginsLine[ 0 ] );
			}
		}
		
		wait ( randomFloatRange( 2.78, 5.95 ) );
	}
}

higginsGoPath( scriptBrushModelRotationFix )
{
	self endon ( "death" );
	
	if( !isDefined( scriptBrushModelRotationFix ) )
	{
		scriptBrushModelRotationFix = 1.95;
	}
	
	goal = self._path[ 0 ];
	count = 0;
	
	while( 1 )
	{
		d = distance( self.origin, goal.origin );
		moveTime = ( d / 150 );
		rotateTime = 1.3; 
		timeOut = 0;
		
		if( isDefined( goal.angles ) )
		{
			self RotateTo( goal.angles * ( scriptBrushModelRotationFix, scriptBrushModelRotationFix, scriptBrushModelRotationFix ), rotateTime, rotateTime * 0.25, rotateTime * 0.25 );
		}
		else
		{
			self RotateTo( VectorToAngles( goal.origin - self.origin ) * ( scriptBrushModelRotationFix, scriptBrushModelRotationFix, scriptBrushModelRotationFix ), rotateTime, rotateTime * 0.25, rotateTime * 0.25 );
		}
		
		self moveTo( goal.origin, moveTime );
		
		if( !isDefined( self._path[ count + 1 ] ) )
		{
			self thread higginsTimeOut();
		}
		
		self waittill_either( "movedone", "timeout" );
		
		count += 1;
		
		if( !isDefined( self._path[ count ] ) )
		{
			break;
		}
		
		goal = self._path[ count ];
		
		wait ( 0.05 );
	}
	
	// Ramp drop
	//self thread higginsDropRamp();
	
	wait ( 0.1 );
	
	// Sink Boat?
	self notify ( "death" );
}

higginsTimeOut()
{
	self endon ( "movedone" );
	
	timeOut = randomIntRange( 5, 10 );
	
	self notify ( "timeout" );
}

higginsTankShotCheck()
{
	tank = getEnt( "higgins_with_tank", "targetname" );
	assertEx( isDefined( tank ), "Sherman not defined in tankShotCheck." );
	flak = getEnt( "flak88_2", "targetname" );
	assertEx( isDefined( flak ), "Flak not defined in tankShotCheck." );
	
	while( 1 )
	{
		if( Distance( flak.origin, tank.origin ) < 5120 )
		{
			flag_set( "tank_higgin_shoot" );
			break;
		}
		
		wait ( 1 );
	}
}

higginsRandomDudes()
{
	level endon ( "ready_for_finale" );
	
	changeUpPos = getEnt( "random_dudes_trigger", "targetname" ); // Color group trigger
	assertEx( isDefined( changeUpPos ), "Reinforcement color trigger not defined." );
	spawners = getEntArray( "random_dudes", "targetname" );
	assertEx( isDefined( spawners ), "Random beach AI spawners not defined." );
	
	max = 23;
	ai = 0;
	
	while( 1 )
	{
		ai = getAiArray( "axis", "allies" );
		
		// Check AI count
		if( ai.size < max )
		{
			// Spawn a guy
			spawners[ RandomInt( spawners.size ) ] stalingradSpawn();
		}
		
		// Change positions!
		if( RandomInt( 100 ) > 40 )
		{
			changeUpPos notify ( "trigger" );
		}
		
		// Fail safe
		if( flag( "ready_for_finale" ) )
		{
			break;
		}
		
		wait ( RandomFloatRange( 3.1, 10.3 ) );
	}
}

bunkerFinale()
{
	// Black
	level.introblack = NewHudElem(); 
	level.introblack.x = 0; 
	level.introblack.y = 0;
	level.introblack.sort = 1;
	level.introblack.horzAlign = "fullscreen"; 
	level.introblack.vertAlign = "fullscreen"; 
	level.introblack SetShader( "black", 640, 480 );
	
	// Set the music state
	setmusicstate( "END" );
	
	// BC Off -- More Cinematic
	battlechatter_off();
	
	// Stop the drone triggers
	level notify ( "end_beach_drones" );
	level notify ( "end_beach_drones2" );
	level notify ( "end_beach_drones3" );
	level notify ( "end_beach_drones4" );
	
	// Get bunker entities
	germanSpawners = getEntArray( "deadBunkerDudes" ,"targetname" );
	assertEx( isDefined( germanSpawners ), "No bunker GER spawners." );
	flameSpawner = getEnt( "player_pwned_ai", "targetname" );
	assertEx( isDefined( flameSpawner ), "No bunker USA spawner." );
	//node = getNode( "player_pwned_ai_goal", "targetname" );
	//assertEx( isDefined( node ), "No bunker USA AI goal node." );
	player_spot = getEnt( "player_pwned_spot", "targetname" );
	assertEx( isDefined( player_spot ), "No bunker player spot defined." );
	
	// Shellshock Blast
	level.player playSound( "grenade_explode" );
	wait ( 0.05 );	
	level.player playSound( "mortar_dirt" );
	
	// Turn the radio off
	//getEnt( "bunkerRadio", "targetname" ) notify ( "death" );
	
	wait ( 0.2 );
	
	// Spawn German AI
	dead = undefined;
	officer = undefined;
	for( x = 0; x < germanSpawners.size; x++ )
	{
		if( isDefined( germanSpawners[ x ].script_noteworthy ) && germanSpawners[ x ].script_noteworthy == "officer" )
		{
			officer = germanSpawners[ x ] stalingradSpawn();
			if( spawn_failed( officer ) )
			{
				printLn( "Officer bunker spawn failed." );
				continue;
			}
			
			officer.animName = "generic";
			officer.health = 5;
			officer thread germanPainScreams();
			officer thread anim_loop_solo( officer, "wounded_bunker", undefined, "damage" );
			officer thread magic_bullet_shield();
		}
		else
		{
			dead = germanSpawners[ x ] stalingradSpawn();
			if( spawn_failed( dead ) )
			{
				printLn( "Dead guy bunker spawn failed." );
				continue;
			}
			
			dead germanDeathScreams();
			dead thread pacifistOn();
			dead thread ignoremeOn();
			dead startRagdoll();
		}
	}
	
	wait ( 1.4 );
	
	// Fade out black
	level.player ShellShock( "frag_grenade_mp", 1.2 );
	level.introblack FadeOverTime( 0.5 ); 
	level.introblack.alpha = 1;
	
	// Player on ground animation
	level thread maps\omahabeach_anim::playerAnimFinale( level.player, player_spot );
	
	// Fade in black
	level.introblack FadeOverTime( 0.5 ); 
	level.introblack.alpha = 0;
	
	wait ( 13.12 );
	
	// Fade in black
	level.introblack FadeOverTime( 0.23 ); 
	level.introblack.alpha = 1;
	
	wait ( 0.28 );
	
	level.default_goalradius = 8; // Goal radius fix for USA guy
	
	flameGuy =  flameSpawner stalingradSpawn();
	if( spawn_failed( flameGuy ) )
	{
		printLn( "Flame guy spawn failed." );
		return;
	}
	
	wait ( 0.45 );
	
	// Fade in black
	level.introblack FadeOverTime( 0.35 ); 
	level.introblack.alpha = 0;
	
	// I start_pointed this many times and it looks good.
	// Always times out perfectly. Wish had noteTracks though for player anim. =0/
	flameGuy bunkerFinale_Flamer();
	//flameGuy setGoalNode( node );
	
	officer thread ignoremeOff();
	level.player thread ignoremeOn();
	
	officer.a.special = "none";
	officer.a.forceflamedeath = true;
	officer.disablearrivals = true;
	officer.disableexits = true;
	officer._ent = spawn( "script_origin", officer.origin );
	
	flameGuy aimAtPos( officer._ent.origin );
	flameGuy OrientMode( "face enemy" );
	//flameGuy Teleport( node.origin, VectorNormalize( officer._ent.origin - flameGuy.origin ) );
	//flameGuy SetEntityTarget( officer._ent );
	//flameGuy shoot();
	
	disable_trigger_with_targetname( "player_pwned_trigger" );
	getEnt( "officer_trigger", "targetname" ) waittill ( "trigger" );
	
	playsoundatposition( "generic_death_german", officer.origin );
	
	wait ( 0.1 );
	
	//flameGuy ClearEntityTarget();
	
	officer thread stop_magic_bullet_shield();
	SetThreatBias( "flameThrowerAI", "officerAI", 0 );
	officer notify ( "damage", officer.health + 1, flameGuy, ( 1, 1, 1 ), ( 1, 1, 1 ), "MOD_BURNED" ); // Stop his animation
	
	if( isAlive( officer ) )
	{
		officer._ent delete();
		officer doDamage( officer.health + 1, (0,0,0) );
	}
	
	level.player._ent = spawn( "script_origin", level.player.origin );
	level.player thread ignoremeOff();
	SetThreatBias( "flameThrowerAI", "player", 100000 );
	
	flameGuy aimAtPos( level.player._ent.origin );
	flameGuy OrientMode( "face enemy" );
	//flameGuy Teleport( flameGuy.origin, VectorNormalize( level.player._ent.origin - flameGuy.origin ) );
	//flameGuy SetEntityTarget( level.player._ent );
	//flameGuy shoot();
	
	wait ( 0.5 );
	
	enable_trigger_with_targetname( "player_pwned_trigger" );
	getEnt( "player_pwned_trigger", "targetname" ) waittill ( "trigger" );
	
	playsoundatposition( "generic_death_german", level.player.origin );
	
	wait ( 0.83 ); // See some flames before black out!
	
	// Fade out black
	level.introblack FadeOverTime( 0.3 ); 
	level.introblack.alpha = 1;
	
	wait ( 0.3 );
	
	//flameGuy ClearEntityTarget();
	flameGuy thread stop_magic_bullet_shield();
	flameGuy delete();
	
	wait ( 0.5 );
	
	// End map
	if( !devCheck( "dontQuitMap" ) )
	{
		endMap();
	}
	else
	{
		level.introblack destroy();
	}
}

endMap()
{
	Changelevel( "" );
}

bunkerFinale_Flamer()
{
	self endon ("death");
	
	self thread magic_bullet_shield();
	self.team = "axis";
	self thread ignoreSuppressionOn();
	self thread ignoremeOn();
	self.disablearrivals = true;
	self.disableexits = true;
	self.goalradius = 8;
	self.fixednode = true;
	
	self.a.flamethrowerShootTime_min = 3500;
	self.a.flamethrowerShootTime_max = 5500;

	self.a.flamethrowerShootDelay_min = 0;
	self.a.flamethrowerShootDelay_max = 0.1;
}

bunkerFinale_FlamerFake( origin, time )
{
	self endon ( "death" );

	tag = self getTagOrigin( "tag_flash" );
	fakeTag = spawn( "script_model", tag );
	fakeTag setModel( "tag_origin" );
	fakeTag.angles = self.angles;
	
	playFxOnTag( level._effect[ "flamethrower_fire" ], fakeTag, "tag_origin" );
	self playSound( "weap_flamethrower_start_3p_scripted" );
	self playLoopSound( "weap_flamethrower_fireloop_3p_scripted" );
	
	wait ( time );
	
	self stopLoopSound();
	
	self playSound( "weap_flamethrower_cooldown_3p" );
	
	wait( 1 );
	
	self stopLoopSound();
	
	fakeTag delete();
}

lightFlicker()
{
	/*
	lamp_off = getEnt( "lamp_off", "targetname" );
	assertEx( isDefined( lamp_off ), "Unlit light script_model not found." );
	lamp_on = getEnt( "lamp_on", "targetname" );
	assertEx( isDefined( lamp_on ), "Lit light script_model not found." );
	*/
	
	light = getEnt( "light", "targetname" );
	//assertEx( tempLight.size >= 1 , "Dynamic light not found." );
	
	if( isDefined( light ) )
	{
		light thread maps\_lights::generic_double_strobe();
	}
	
	/*
	for(;;)
	{
		lamp_on show();
		lamp_off hide();
		light setLightIntensity( intensity );
		wait( RandomFloatRange( 0.3, 0.7 ) );
		
		lamp_on hide();
		lamp_off show();
		light setLightIntensity( 0 );
		wait( RandomFloatRange( 0.1, 0.4 ) );
		
		lamp_on show();
		lamp_off hide();
		light setLightIntensity( intensity );
		wait( RandomFloatRange( 0.5, 0.9 ) );
		
		lamp_on show();
		lamp_off hide();
		light setLightIntensity( 0 );
		wait( RandomFloatRange( 0.1, 0.3 ) );
	}
	*/
}

/***********************************************************************
	NETWORKING
***********************************************************************/ 

onPlayerConnect()
{
	for( ;; )
	{
		level waittill( "connecting", player ); 

		player thread onPlayerDisconnect(); 
		player thread onPlayerSpawned(); 
		player thread onPlayerKilled(); 
	
		println( "Player connected to game." ); 
	}
}

onPlayerDisconnect()
{
	self waittill( "disconnect" ); 

	println( "Player disconnected from the game." ); 
}

onPlayerSpawned()
{
	self endon( "disconnect" ); 
	
	for( ;; )
	{
		self waittill( "spawned_player" ); 
		self SetThreatBiasGroup( "player" );
		self EnableInvulnerability(); 	
			
		println( "Player spawned in to game at " + self.origin );
	}
}

onPlayerKilled()
{
	self endon( "disconnect" ); 
	
	for( ;; )
	{
		self waittill( "killed_player" ); 

		println( "Player killed at " + self.origin );
	}
}