#include maps\_utility; 
#include common_scripts\utility;

main()
{
	maps\createfx\omahabeach_fx::main();
	maps\createart\omahabeach_art::main();

	scriptedFX();
	precache_fx();
	precache_createfx_fx();
	footsteps();	
	level thread wind_settings();
	level thread water_settings();
}

scriptedFX()
{
	level._effect["distant_muzzleflash"]		=	loadfx("weapon/tracer/fx_muz_distnt_lg_wrld");
	level._effect["side_smoke"] = loadfx("maps/pel1/fx_smokebank_beach_xxlg");
	level._effect["flamethrower_fire"]				= loadfx("maps/sniper/fx_flamethrower_burst");
}

precache_fx()
{
	level._effectType[ "beach_mortars" ] 					= "mortar";
	level._effect[ "beach_mortars" ]						= loadfx( "explosions/fx_mortarExp_dirt_airfield" );		
	level._explosion_stopNotify[ "beach_mortars" ] 			= "stop_beach_mortars";
	
	level._effectType["water_mortars"] 		= "mortar_water";
	level._effect["water_mortars"]					= loadfx("explosions/mortarExp_water");	
	level._explosion_stopNotify[ "water_mortars" ] 			= "stop_water_mortars";
}

precache_createfx_fx()
{
	level._effect["a_smoke_plume_xlg_slow_blk"] = loadfx ("env/smoke/fx_smoke_plume_xlg_slow_blk");
	level._effect["a_smoke_plume_xlg_slow_blk_tall"] = loadfx ("env/smoke/fx_smoke_plume_xlg_slow_blk_tall_w");
  level._effect["a_smk_column_lg_blk"]		    = loadfx ("env/smoke/fx_smk_column_lg_blk");
  level._effect["smoke_rolling_thick"]			= loadfx ("maps/pel1/fx_smoke_rolling_thick");
  level._effect["smoke_rolling_thick2"]			= loadfx ("maps/pel1/fx_smoke_rolling_thick2");
  level._effect["lingering_cliff_smoke_w"]	= loadfx ("env/smoke/fx_smoke_artillery_barrage_w");
  
  level._effect["smoke_impact_smolder"]		      = loadfx ("maps/pel1/fx_smoke_crater_w");
  
  level._effect["player_water_blood_cloud"]		    = loadfx ("env/water/fx_water_blood_cloud_player");	
  level._effect["med_water_blood_cloud"]					= loadfx ("env/water/fx_water_blood_cloud_256x256");
  level._effect["large_water_blood_cloud"]		    = loadfx ("env/water/fx_water_blood_cloud_512x512");
  level._effect["xlarge_water_blood_cloud"]		    = loadfx ("env/water/fx_water_blood_cloud_1024x1024");
  
  level._effect["detail_fire"]	= loadfx ("env/fire/fx_fire_rubble_detail");
  level._effect["small_fire"]	= loadfx ("env/fire/fx_fire_smoke_tree_brush_small_w");
  level._effect["med_fire"]	= loadfx ("env/fire/fx_fire_smoke_tree_brush_med_w");
  level._effect["trunk_fire"]	= loadfx ("env/fire/fx_fire_smoke_tree_trunk_med_w");
  
  level._effect["bunker_dust"]	= loadfx ("maps/pel1/fx_bunker_dust_ceiling_impact");
	level._effect["bunker_dust_ambient"]	= loadfx ("maps/pel1/fx_bunker_dust_ceiling_impact_ambient");
	
	level._effect["godray_small"]	= loadfx ("env/light/fx_ray_sun_small");
	level._effect["godray_small_short"]	= loadfx ("maps/pel1/fx_godray_small_short");
	level._effect["godray_small_short2"]	= loadfx ("maps/pel1/fx_godray_small_short2");
	
	level._effect["tide_splash_small"] = loadfx ("env/water/fx_water_splash_tide_small");
	level._effect["tide_splash_med"] = loadfx ("env/water/fx_water_splash_tide_med");
	level._effect["tide_splash_large"] = loadfx ("env/water/fx_water_splash_tide_lrg");
	
	level._effect["ash_and_embers"] = loadfx ("env/fire/fx_tree_fire_ash_embers");
	level._effect["large_fire_distant"] = loadfx ("env/fire/fx_fire_large_distant");
	level._effect["xlarge_fire_distant"] = loadfx ("env/fire/fx_fire_xlarge_distant");
	
	level._effect["heat_haze_medium"] = loadfx ("maps/pel1/fx_heathaze_md");	
	level._effect["ash_cloud_1"] = loadfx ("maps/pel1/fx_ash_cloud");	
	level._effect["dust_kick_up_emitter"] = loadfx ("maps/pel1/fx_dust_kick_up_emitter");
	level._effect["dust_ambiance_tunnel"] = loadfx ("maps/pel1/fx_dust_ambiance_tunnel");
}

footsteps()
{
    animscripts\utility::setFootstepEffect( "asphalt",	LoadFx( "bio/player/fx_footstep_dust" ) ); 
    animscripts\utility::setFootstepEffect( "brick",	LoadFx( "bio/player/fx_footstep_dust" ) ); 
    animscripts\utility::setFootstepEffect( "carpet",	LoadFx( "bio/player/fx_footstep_dust" ) ); 
    animscripts\utility::setFootstepEffect( "cloth",	LoadFx( "bio/player/fx_footstep_dust" ) ); 
    animscripts\utility::setFootstepEffect( "concrete",	LoadFx( "bio/player/fx_footstep_dust" ) ); 
    animscripts\utility::setFootstepEffect( "dirt",		LoadFx( "bio/player/fx_footstep_sand" ) ); 
    animscripts\utility::setFootstepEffect( "foliage",	LoadFx( "bio/player/fx_footstep_sand" ) ); 
    animscripts\utility::setFootstepEffect( "gravel",	LoadFx( "bio/player/fx_footstep_dust" ) ); 
    animscripts\utility::setFootstepEffect( "grass",	LoadFx( "bio/player/fx_footstep_dust" ) ); 
    animscripts\utility::setFootstepEffect( "metal",	LoadFx( "bio/player/fx_footstep_dust" ) ); 
    animscripts\utility::setFootstepEffect( "mud",		LoadFx( "bio/player/fx_footstep_mud" ) ); 
    animscripts\utility::setFootstepEffect( "paper",	LoadFx( "bio/player/fx_footstep_dust" ) ); 
    animscripts\utility::setFootstepEffect( "plaster",	LoadFx( "bio/player/fx_footstep_dust" ) ); 
    animscripts\utility::setFootstepEffect( "rock",		LoadFx( "bio/player/fx_footstep_dust" ) ); 
    animscripts\utility::setFootstepEffect( "sand",		LoadFx( "bio/player/fx_footstep_sand" ) ); 
    animscripts\utility::setFootstepEffect( "water",	LoadFx( "bio/player/fx_footstep_water" ) ); 
    animscripts\utility::setFootstepEffect( "wood",		LoadFx( "bio/player/fx_footstep_dust" ) );
}

// Global Wind Settings
wind_settings()
{
	SetSavedDvar( "wind_global_vector", "-178 140 0" );
	SetSavedDvar( "wind_global_low_altitude", -500 );
	SetSavedDvar( "wind_global_hi_altitude", 1600 );
	SetSavedDvar( "wind_global_low_strength_percent", 0.2 );
}

water_settings()
{
	SetDvar( "r_watersim_waveSeedDelay", 100.0 );
	SetDvar( "r_watersim_curlAmount", 0.18 );
	SetDvar( "r_watersim_curlMax", 0.2 );
	SetDvar( "r_watersim_curlReduce", 0.95 );
	SetDvar( "r_watersim_minShoreHeight", 0.04 );
	SetDvar( "r_watersim_foamAppear", 20.0 );
	SetDvar( "r_watersim_foamDisappear", 0.45 );
	SetDvar( "r_watersim_windAmount", 0.026 );
	SetDvar( "r_watersim_windDir", 75 );
	SetDvar( "r_watersim_windMax", 1.96 );
	SetDvar( "r_watersim_particleGravity", 0.03 );
	SetDvar( "r_watersim_particleLimit", 2.5 );
	SetDvar( "r_watersim_particleLength", 0.03 );
	SetDvar( "r_watersim_particleWidth", 2.0 );	
}